# Polythene documentation


## Getting started

* [Introduction](introduction.md)
* [Getting started with Mithril](getting-started-mithril.md)
* [Getting started with React](getting-started-react.md)

## Online examples

* [List of Mithril examples](online-examples-mithril.md)
* [List of React examples](online-examples-react.md)

## Topics

* [CSS](css.md)
* [Theming](theming.md)
  * [Light and dark](theming/light-and-dark.md)
  * [Configuration variables](theming/configuration-variables.md)
  * [Wrapper components](theming/wrapper-components.md)
  * [Global theme file](theming/global-theme-file.md)
  * [Custom CSS](theming/custom-css.md)
* [Transitions](transitions.md)
* [Handling state](handling-state.md)
* [URLs and router links](handling-urls.md)

## Components

* [Buttons](components/buttons.md)
  * [Button](components/button.md)
  * [FAB](components/fab.md)
  * [Icon Button](components/icon-button.md)
  * [Raised Button](components/raised-button.md)
* [Card](components/card.md)
* [Dialog](components/dialog.md)
* [Drawer](components/drawer.md)
* [Icon](components/icon.md)
* [Inputs and Controls](components/inputs-and-controls.md)
  * [Checkbox](components/checkbox.md)
  * [Radio Button](components/radio-button.md)
  * [Radio Group](components/radio-group.md)
  * [Selection Control](components/selection-control.md)
  * [Slider](components/slider.md)
  * [Switch](components/switch.md)
  * [Text Field](components/textfield.md)
* [List](components/list.md)
* [List Tile](components/list-tile.md)
* [Menu](components/menu.md)
* [Notifications](components/notifications.md)
  * [Notification](components/notification.md)
  * [Snackbar](components/snackbar.md)
* [Ripple](components/ripple.md)
* [Search](components/search.md)
* [Shadow](components/shadow.md)
* [Spinner](components/spinner.md)
* [SVG](components/svg.md)
* [Tabs](components/tabs.md)
* [Toolbar](components/toolbar.md)

## Mithril components

* [Buttons](components/mithril/buttons.md)
  * [Button](components/mithril/button.md)
  * [FAB](components/mithril/fab.md)
  * [Icon Button](components/mithril/icon-button.md)
  * [Raised Button](components/mithril/raised-button.md)
* [Card](components/mithril/card.md)
* [Dialog](components/mithril/dialog.md)
* [Drawer](components/mithril/drawer.md)
* [Icon](components/mithril/icon.md)
* [Inputs and Controls](components/mithril/inputs-and-controls.md)
  * [Checkbox](components/mithril/checkbox.md)
  * [Radio Button](components/mithril/radio-button.md)
  * [Radio Group](components/mithril/radio-group.md)
  * [Slider](components/mithril/slider.md)
  * [Switch](components/mithril/switch.md)
  * [Text Field](components/mithril/textfield.md)
* [List](components/mithril/list.md)
* [List Tile](components/mithril/list-tile.md)
* [Menu](components/mithril/menu.md)
* [Notifications](components/mithril/notifications.md)
  * [Notification](components/mithril/notification.md)
  * [Snackbar](components/mithril/snackbar.md)
* [Ripple](components/mithril/ripple.md)
* [Search](components/mithril/search.md)
* [Shadow](components/mithril/shadow.md)
* [Spinner](components/mithril/spinner.md)
* [SVG](components/mithril/svg.md)
* [Tabs](components/mithril/tabs.md)
* [Toolbar](components/mithril/toolbar.md)

## React components

* [Buttons](components/react/buttons.md)
  * [Button](components/react/button.md)
  * [FAB](components/react/fab.md)
  * [Icon Button](components/react/icon-button.md)
  * [Raised Button](components/react/raised-button.md)
* [Card](components/react/card.md)
* [Dialog](components/react/dialog.md)
* [Drawer](components/react/drawer.md)
* [Icon](components/react/icon.md)
* [Inputs and Controls](components/react/inputs-and-controls.md)
  * [Checkbox](components/react/checkbox.md)
  * [Radio Button](components/react/radio-button.md)
  * [Radio Group](components/react/radio-group.md)
  * [Slider](components/react/slider.md)
  * [Switch](components/react/switch.md)
  * [Text Field](components/react/textfield.md)
* [List](components/react/list.md)
* [List Tile](components/react/list-tile.md)
* [Menu](components/react/menu.md)
* [Notifications](components/react/notifications.md)
  * [Notification](components/react/notification.md)
  * [Snackbar](components/react/snackbar.md)
* [Ripple](components/react/ripple.md)
* [Search](components/react/search.md)
* [Shadow](components/react/shadow.md)
* [Spinner](components/react/spinner.md)
* [SVG](components/react/svg.md)
* [Tabs](components/react/tabs.md)
* [Toolbar](components/react/toolbar.md)

## And also

* [Change log](docs/changes.md)
* [Extending other libraries](extending.md)
* [Developing](developing.md)
* [Additional Polythene packages](packages.md)
* [Migrating from 0.2](migrating-from-02.md)
* [Known issues](known-issues.md)

