# List of online Polythene examples for React

## Demo site

* [React demo site](https://arthurclemens.github.io/polythene-demos/react/)

## Live examples

Try out Polythene in JSFiddles.

## JSX

### Topics

* [Router links](https://jsfiddle.net/ArthurClemens/1hm2w5xd/)

### Components

* Buttons
  * [Button](https://jsfiddle.net/ArthurClemens/5db99xoj/)
  * [FAB](https://jsfiddle.net/ArthurClemens/nj11av54/)
  * [Icon Button](https://jsfiddle.net/ArthurClemens/xuo1gow5/)
  * [Raised Button](https://jsfiddle.net/ArthurClemens/sbtonwbf/)
* [Card](https://jsfiddle.net/ArthurClemens/dhq3cLrv/)
* Dialog
  * [Dialog layout, styling and opening](https://jsfiddle.net/ArthurClemens/m08o291L/)
  * [Full screen dialog](https://jsfiddle.net/ArthurClemens/npq4phf3/)
  * [Dynamic content (Passing dialog options as a function)](https://jsfiddle.net/ArthurClemens/1fgh0bgt/)
  * [Dynamic content (Continuously calling Dialog.show)](https://jsfiddle.net/ArthurClemens/oe91vy6f/)
* [Drawer](https://jsfiddle.net/ArthurClemens/25tL4aqr/)
* [Icon](https://jsfiddle.net/ArthurClemens/ep9pf5wp/)
* Inputs and Controls
  * [Checkbox](https://jsfiddle.net/ArthurClemens/hp6ksg2m/)
  * [Radio Button](https://jsfiddle.net/ArthurClemens/b1vbbLgw/)
  * [Slider](https://jsfiddle.net/ArthurClemens/6crka9hy/)
  * [Switch](https://jsfiddle.net/ArthurClemens/orqdxd4a/)
  * [Text Field](https://jsfiddle.net/ArthurClemens/dz21hu8c/)
    * [Text Field form validation](https://jsfiddle.net/ArthurClemens/h2uyf1zh/)
* Lists  
  * [List](https://jsfiddle.net/ArthurClemens/yzba5Lvn/)
  * [List with keyboard control](https://jsfiddle.net/ArthurClemens/hv8kcfs1/)
  * [List Tile](https://jsfiddle.net/ArthurClemens/gmdcvjeL/)
* Menu
  * [Menu layout and styling](https://jsfiddle.net/ArthurClemens/gta0c3te/)
  * [Menu opening variations](https://jsfiddle.net/ArthurClemens/Lm1o6f9y/)
* Notifications
  * [Notification](https://jsfiddle.net/ArthurClemens/c3wsbhj0/)
  * [Snackbar](https://jsfiddle.net/ArthurClemens/4edrmz42/)
* [Ripple](https://jsfiddle.net/ArthurClemens/brx9wdhv/)
* Search
  * [Search field](https://jsfiddle.net/ArthurClemens/qm85uyd9/)
  * [Search with result list](https://jsfiddle.net/ArthurClemens/48oay6Lj/)
* [Shadow](https://jsfiddle.net/ArthurClemens/uej4sw3q/)
* [Spinner](https://jsfiddle.net/ArthurClemens/ykshk90g/)
* [SVG](https://jsfiddle.net/ArthurClemens/qm31tx7b/)
* [Tabs](https://jsfiddle.net/ArthurClemens/zoppbr7t/)
* [Toolbar](https://jsfiddle.net/ArthurClemens/rgmzx6jr/)


## Hyperscript

### Topics

* [Router links](https://jsfiddle.net/ArthurClemens/gqef8c0g/)

### Components

* Buttons
  * [Button](https://jsfiddle.net/ArthurClemens/5z374g58/)
  * [FAB](https://jsfiddle.net/ArthurClemens/Lebqe5g2/)
  * [Icon Button](https://jsfiddle.net/ArthurClemens/xh7jgutu/)
  * [Raised Button](https://jsfiddle.net/ArthurClemens/hL8wmrpL/)
* [Card](https://jsfiddle.net/ArthurClemens/h6n5jzgd/)
* Dialog: no hyperscript examples yet
* [Icon](https://jsfiddle.net/ArthurClemens/qhh725aa/)
* Inputs and Controls
  * [Checkbox](https://jsfiddle.net/ArthurClemens/g07snvox/)
  * [Radio Button](https://jsfiddle.net/ArthurClemens/fhqrcuL9/)
  * [Slider](https://jsfiddle.net/ArthurClemens/ekht8sef/)
  * [Switch](https://jsfiddle.net/ArthurClemens/0eaeadbm/)
  * [Text Field](https://jsfiddle.net/ArthurClemens/yug5s0ha/)
* [List](https://jsfiddle.net/ArthurClemens/3vdfmg8p/)
* [List Tile](https://jsfiddle.net/ArthurClemens/mc9kaqgc/)
* Menu
  * [Menu layout and styling](https://jsfiddle.net/ArthurClemens/umrnvm13/)
  * [Menu opening variations](https://jsfiddle.net/ArthurClemens/fzcys56b/)
* Notifications
  * [Notification](https://jsfiddle.net/ArthurClemens/08g6aqpd/)
  * [Snackbar](https://jsfiddle.net/ArthurClemens/opx44Lhq/)
* [Ripple](https://jsfiddle.net/ArthurClemens/L0e0bb68/)
* Search
  * [Search field](https://jsfiddle.net/ArthurClemens/hruxczph/)
* [Shadow](https://jsfiddle.net/ArthurClemens/ohuxgfef/)
* [Spinner](https://jsfiddle.net/ArthurClemens/j74x8b9w/)
* [SVG](https://jsfiddle.net/ArthurClemens/3v5v5kdb/)
* [Tabs](https://jsfiddle.net/ArthurClemens/hd68eu6n/)
* [Toolbar](https://jsfiddle.net/ArthurClemens/dg9f6day/)

